#include <iostream>
#include <vector>
#include "calc.h"

bool compute (const std::string polexp, double &result) {
    std::vector<double> stack;
    int startch = -1;
    int endch = -1;
    int endflag = -1;
    bool numflag = false;
    std::string subs;
    double N1, N2, R;
    unsigned int n = 0;
    bool err = false;
    
    while (! err && n < polexp.size ()) {
	if (isdigit (polexp.at (n)) || polexp.at (n) == '.') {
	    if (! numflag)
		numflag = true;
	    if (endch == endflag) {
		endch = n;
		startch = n;
	    }
	    else {
		endch = n;
	    }
	}
	else {
	    if (numflag) {
		numflag = false;
		subs = polexp.substr (startch, endch - startch + 1) + '\0';
		N1 = exptof (subs);
		stack.push_back (N1);
//    std::cout << "push to stack: " << N1 << '\n';
		endflag = n;
		endch = n;
		startch = n;
	    }
	    switch (polexp.at (n)) {
	        case '+':
		    N2 = stack.back ();
		    stack.pop_back ();
		    N1 = stack.back ();
		    stack.pop_back ();
		    R = N1 + N2;
		    stack.push_back (R);
		    break;
		case '-':
		    N2 = stack.back ();
		    stack.pop_back ();
		    N1 = stack.back ();
		    stack.pop_back ();
		    R = N1 - N2;
		    stack.push_back (R);
		    break;
		case '*':
		    N2 = stack.back ();
		    stack.pop_back ();
		    N1 = stack.back ();
		    stack.pop_back ();
		    R = N1 * N2;
		    stack.push_back (R);
		    break;
		case '/':
		    N2 = stack.back ();
		    stack.pop_back ();
		    N1 = stack.back ();
		    stack.pop_back ();
		    if (N2 == 0) {
			err = true;
			std::cout << "Result: Infinitive" << '\n';
		    }
		    else {
			R = N1 / N2;
			stack.push_back (R);
		    }
		    break;
		case '_':
		    N1 = stack.back ();
		    stack.pop_back ();
		    R = N1 * (-1);
		    stack.push_back (R);
		    break;
		case '~':
		    break;
		default:
		    break;
	    }
	}
	n++;
    }

    if (stack.size () > 1)
	std::cout << "Error - stack size > 1." << '\n';
    result = stack.back ();
    return (! err);
}
